<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Klachten extends Controller_DefaultTemplate {
	
	public function action_index()
	{
		$this->redirect('klachten/nieuw');
	}
	
	/* VIEWS */
	public function action_nieuw()
	{
		$mdl= new Model_Klachten();
		$content['slReden']=$mdl->getReden();
		$mdl= new Model_Leeggoed();
		$content['slLeeggoed']=$mdl->slLeeggoed();
		$this->template->nav = View::factory('nav/klachten');
		$this->template->content = View::factory('klachten/nieuw',$content);
	}
	
	public function action_open()
	{
		$this->template->nav = View::factory('nav/klachten');
		$this->template->content = View::factory('klachten/open');
	}
	
	public function action_all()
	{
		$this->template->nav = View::factory('nav/klachten');
		$this->template->content = View::factory('klachten/all');
	}
	
	/* VIEW DETAIL - BLOCKS */
	public function action_vwLeverancierBestelBon()
	{
		$mdl= new Model_Orders();
		$content['bestellingen']= $mdl->getBestelBon($_POST['leverancierid'],$_POST['artikelid']);
		echo View::factory('klachten/bl_bestelling',$content);
	}
	
	public function action_vwBewerkKlacht()
	{
		$mdl= new Model_Klachten();
		$content['inspectie']=$mdl->getInspectie();
		$content['actie']=$mdl->getActie();
		$content['geg']= $mdl->getDetailKlacht($_POST['klachtid']);
		echo View::factory('klachten/bl_open',$content);
	}
	
	public function action_vwDetailKlacht()
	{
		$mdl= new Model_Klachten();
		$content['geg']= $mdl->getDetailKlacht($_POST['klachtid']);
		echo View::factory('klachten/bl_detail',$content);
	}
	
	/* UPLOAD */
	public function action_uploadDoc()
    {
        $response['files'] = array();
        try {
			$doc=$_FILES['files'];
			$filename = $doc['tmp_name'];
            $ext = pathinfo($doc['name'], PATHINFO_EXTENSION);
            $file=str_replace(" ","_",$doc['name']);
            $path = getcwd().'/assets/upload/'.$file;
				
			//validator
			$validextensions=array('pdf','csv','doc','docx','xls','xlsx','jpeg','jpg','png');
			$valid=in_array($ext,$validextensions);
            if(!$valid){
				throw new Exception("File has an incorrect extension");
            }

            if (is_uploaded_file($filename)) {
                if ($doc['error'] == UPLOAD_ERR_OK) {
                    // save file in directory
                    if (move_uploaded_file($filename,$path)) {
                        $response['files'][0]['name'] = $file;
                        $response['files'][0]['size'] = $doc['size'];
                        $response['files'][0]['url'] = $file;
                        $response['files'][0]['thumbnailUrl'] = $file;
                        $response['files'][0]['deleteUrl'] = $file;
                        $response['files'][0]['deleteType'] = "DELETE";
                    }
                } else {
                    throw new Exception($doc['error']);
                }
             } else {
                throw new Exception("File is NOT uploaded.");
             }
        } catch (Exception $e) {
            $response['files'][0]['error'] = "<p>The file (". $doc['name'].") didn't saved because following errors occur:</p><p>".$e->getMessage()."</p>";
        }
		echo json_encode($response);
    }
	
	/* PDF's */
	public function action_pdfKlacht()
	{
		try{
		$this->profiler = NULL;
		$this->auto_render = FALSE;
		$this->response->headers('Content-Type','application/pdf');
		
		$mdl= new Model_Klachten();
		$klacht=$mdl->getDetailKlacht($_GET['klachtid']);
		Log::instance()->add(Log::INFO, json_encode($klacht));	
		include('assets/pdf/klacht_pdf.php');
		// FPDF object
		$bpdf = new KlachtPDF();
		$bpdf->SetAutoPageBreak(true, 10);
		$bpdf->setGegevens($klacht['klacht'][0]);
		$bpdf->AliasNbPages();
		$bpdf->SetDisplayMode(100);
		$bpdf->SetFont('Helvetica','',10);
		$bpdf->AddPage();
		if(!empty(trim($klacht['klacht'][0]['opmerking']))){
			$bpdf->InfoTabel($klacht['klacht'][0]['opmerking']);
		}
		if(!empty($klacht['leeggoed'][0]['klachtleeggoedid'])){
			$bpdf->LeeggoedTabel($klacht['leeggoed']);
		}
		$bpdf->KlachtTabel($klacht['klacht']);
		if(!empty(trim($klacht['klacht'][0]['docs']))){
			$bpdf->ImgTabel($klacht['klacht'][0]['docs']);
		}
		$bpdf->Output('klacht.pdf','I');
		}catch(Exception $error){
			Log::instance()->add(Log::ERROR, $error->getMessage());		
			$this->redirect('klachten/all');
		}

	}
	
	/* DATA TABLE */
	public function action_tblKlachten()
	{	
		$mdl= new Model_Klachten();
	    $output = $mdl->getDataKlachten();
		echo json_encode($output);
	}
	
	/* SETTERS */
	public function action_addKlacht()
	{	
		$mdl= new Model_Klachten();
	    $output = $mdl->setKlacht($_POST);
		echo json_encode($output);
	}
	
	public function action_saveKlacht()
	{	
		$mdl= new Model_Klachten();
	    $output = $mdl->saveKlacht($_POST);
		echo json_encode($output);
	}
}